﻿using System;
using UnityEngine;

namespace ICODES.STUDIO.WWebView
{
	public class WWebViewListener : MonoBehaviour
	{
		public WWebView WebView { get; set; }

		public string Name
		{
			get
			{
				return base.gameObject.name;
			}
		}

		private void WebViewDone(string message)
		{
			this.WebView.InternalOnClose();
		}

		private void LoadBegin(string url)
		{
			this.WebView.InternalOnStartNavigation(url);
		}

		private void LoadComplete(string message)
		{
			this.WebView.InternalOnNavigationCompleted(message);
		}

		private void EvalJavaScriptFinished(string result)
		{
			this.WebView.InternalOnEvaluateJavaScript(result);
		}

		private void ReceivedMessage(string result)
		{
			this.WebView.InternalOnReceiveMessage(result);
		}

		[Serializable]
		public class WWebViewResultPayload
		{
			public string identifier;

			public string resultCode;

			public string data;
		}
	}
}
