﻿using System;
using System.Runtime.InteropServices;
using System.Text;
using UnityEngine;
using Win32;

namespace ICODES.STUDIO.WWebView
{
	public class WWebViewWin32
	{
		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern int Initialize(IntPtr mainInstance, IntPtr prevInstance, string commandLine, int commandShow, IntPtr windowTemplate, int windowWidth, int windowHeight, int version);

		[DllImport("Win32-WebView")]
		public static extern bool SetResizeMode(uint mode);

		[DllImport("Win32-WebView")]
		public static extern void Release();

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern bool Create(string name, WWebViewWin32.ActionDocumentComplete documentComplete, WWebViewWin32.ActionBeforeNavigate beforeNavigate, WWebViewWin32.ActionWindowClosing windowClosing, WWebViewWin32.ActionTitleChange titleChange, WWebViewWin32.ActionNewWindow newWindow, WWebViewWin32.ActionNavigateComplete navigateComplete, int left, int top, int right, int bottom, int width, int height, bool popup);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Navigate(string name, string url);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void NavigateToString(string name, string text);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern IntPtr AddJavaScript(string name, string script);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern IntPtr EvaluateJavaScript(string name, string script);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Destroy(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void EnableContextMenu(string name, bool enable);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void CleanCache();

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void CleanCookie(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern IntPtr GetCookie(string url, string key);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetCookie(string url, string cookie);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Refresh(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void GoBack(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void GoForward(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Stop(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Show(string name, bool show);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void ChangeLayout(string name, int left, int top, int right, int bottom, int width, int height);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern IntPtr CurrentUrl(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void AddUrlScheme(string name, string scheme);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void RemoveUrlScheme(string name, string scheme);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetZoom(string name, int factor);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetUserAgent(string name, string userAgent);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern IntPtr GetUserAgent(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetTexture(string name, IntPtr texture, int width, int height);

		[DllImport("Win32-WebView")]
		public static extern IntPtr GetRenderEventFunc();

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void Transparent(string name, bool transparent);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern float GetAlpha(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetAlpha(string name, float alpha);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern int GetActualWidth(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern int GetActualHeight(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void ShowScroll(string name, bool show);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void ShowScrollX(string name, bool show);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void ShowScrollY(string name, bool show);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetTitleText(string name, string text);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern bool CanGoBack(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern bool CanGoForward(string name);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetSilent(string name, bool mode);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void InputEvent(string name, int state, int key, int x, int y);

		[DllImport("Win32-WebView", CharSet = CharSet.Auto)]
		public static extern void SetHeaderField(string name, string key, string value);

		[DllImport("Win32-WebView")]
		public static extern void DispatchAccelerator();

		public static void DispatchMessage()
		{
			WWebViewWin32.DispatchAccelerator();
		}

		public static bool ModifyStyle(IntPtr window, long remove, long add, uint flags)
		{
			IntPtr windowLong = User32.GetWindowLong(window, -16);
			IntPtr intPtr = new IntPtr(((long)windowLong.ToInt32() & ~remove) | add);
			if (windowLong == intPtr)
			{
				return false;
			}
			User32.SetWindowLong(window, -16, intPtr);
			if (flags != 0u)
			{
				User32.SetWindowPos(window, IntPtr.Zero, 0, 0, 0, 0, 23u | flags);
			}
			return true;
		}

		public static IntPtr FindUnityPlayerWindow()
		{
			IntPtr intPtr = WWebViewWin32.FindUnityWindow("UnityWndClass", null);
			if (intPtr != IntPtr.Zero)
			{
				return intPtr;
			}
			return User32.FindWindow("UnityWndClass", Application.productName);
		}

		public static IntPtr FindUnityEditorWindow()
		{
			return WWebViewWin32.FindUnityWindow("UnityContainerWndClass", "Unity");
		}

		public static IntPtr FindUnityWindow(string targetClassName, string prefixWindowText = null)
		{
			uint currentProcessId = Kernel32.GetCurrentProcessId();
			IntPtr intPtr = User32.GetTopWindow(IntPtr.Zero);
			while (intPtr != IntPtr.Zero)
			{
				uint num;
				User32.GetWindowThreadProcessId(intPtr, out num);
				if (num == currentProcessId && User32.IsWindowVisible(intPtr) != 0)
				{
					StringBuilder stringBuilder = new StringBuilder(1024);
					User32.GetClassName(intPtr, stringBuilder, stringBuilder.Capacity);
					if (stringBuilder.ToString() == targetClassName)
					{
						StringBuilder stringBuilder2 = new StringBuilder(1024);
						User32.GetWindowText(intPtr, stringBuilder2, stringBuilder2.Capacity);
						if (string.IsNullOrEmpty(prefixWindowText) || stringBuilder2.ToString().StartsWith(prefixWindowText))
						{
							return intPtr;
						}
					}
				}
				intPtr = User32.GetWindow(intPtr, 2u);
			}
			return IntPtr.Zero;
		}

		public static void SubclassWindow()
		{
			IntPtr hWnd = WWebViewWin32.FindUnityPlayerWindow();
			WWebViewWin32.ActionWindowProc d = new WWebViewWin32.ActionWindowProc(WWebViewWin32.WindowProc);
			IntPtr functionPointerForDelegate = Marshal.GetFunctionPointerForDelegate(d);
			WWebViewWin32.defaultWindowProc = User32.SetWindowLong(hWnd, -4, functionPointerForDelegate);
		}

		public static void UnsubclassWindow()
		{
			if (WWebViewWin32.defaultWindowProc != IntPtr.Zero)
			{
				User32.SetWindowLong(WWebViewWin32.FindUnityPlayerWindow(), -4, WWebViewWin32.defaultWindowProc);
				WWebViewWin32.defaultWindowProc = IntPtr.Zero;
			}
		}

		private static IntPtr DefWindowProc(IntPtr window, uint message, IntPtr wparam, IntPtr lparam)
		{
			if (WWebViewWin32.defaultWindowProc != IntPtr.Zero)
			{
				return User32.CallWindowProc(WWebViewWin32.defaultWindowProc, window, message, wparam, lparam);
			}
			return User32.DefWindowProcW(window, message, wparam, lparam);
		}

		private static IntPtr WindowProc(IntPtr window, uint message, IntPtr wparam, IntPtr lparam)
		{
			bool flag = false;
			IntPtr result = IntPtr.Zero;
			if (message == 16u)
			{
				flag = WWebViewWin32.OnClose(window, message, wparam, lparam, ref result);
			}
			if (!flag)
			{
				result = WWebViewWin32.DefWindowProc(window, message, wparam, lparam);
			}
			return result;
		}

		private static bool OnClose(IntPtr window, uint message, IntPtr wparam, IntPtr lparam, ref IntPtr result)
		{
			WWebViewWin32.UnsubclassWindow();
			Application.Quit();
			return true;
		}

		private static IntPtr defaultWindowProc = IntPtr.Zero;

		private static MSG lastMsg;

		public delegate void ActionDocumentComplete(IntPtr name, IntPtr url);

		public delegate void ActionBeforeNavigate(IntPtr name, IntPtr url, IntPtr message, ref bool cancel);

		public delegate void ActionWindowClosing(IntPtr name, bool childWindow, ref bool cancel);

		public delegate void ActionTitleChange(IntPtr name, IntPtr title);

		public delegate void ActionNewWindow(IntPtr name, ref bool cancel);

		public delegate void ActionNavigateComplete(IntPtr name, IntPtr url);

		public delegate IntPtr ActionWindowProc(IntPtr window, uint message, IntPtr wparam, IntPtr lparam);
	}
}
