﻿using System;

public class PrivateCharaSelectMove : WfScreenChildren
{
	public override void Awake()
	{
		base.Awake();
		base.SetFadeTime(0f);
	}

	public void SetNextLabel(string label)
	{
		this.m_nextLabel = label;
	}

	public void SetBackupFile(string fileName)
	{
		this.m_backupFile = fileName;
	}

	protected override void OnCall()
	{
	}

	public override void Update()
	{
		base.Update();
		if (base.fade_status == WfScreenChildren.FadeStatus.Wait)
		{
			this.Finish();
		}
	}

	protected override void OnFinish()
	{
		base.OnFinish();
		if (!string.IsNullOrEmpty(this.m_nextLabel) && !string.IsNullOrEmpty(this.m_backupFile))
		{
			string nextLabel = this.m_nextLabel;
			string backupFile = this.m_backupFile;
			this.m_nextLabel = string.Empty;
			this.m_backupFile = string.Empty;
			GameMain.Instance.ScriptMgr.adv_kag.LoadScriptFile(backupFile, string.Empty);
			GameMain.Instance.ScriptMgr.adv_kag.JumpLabel(nextLabel);
			GameMain.Instance.ScriptMgr.adv_kag.Exec();
		}
	}

	protected override void FadeIn()
	{
		base.FadeIn();
		if (base.fade_status == WfScreenChildren.FadeStatus.Wait)
		{
			this.Finish();
		}
	}

	public bool IsExistNextFile()
	{
		return !string.IsNullOrEmpty(this.m_nextLabel) && !string.IsNullOrEmpty(this.m_backupFile);
	}

	public string NextLabel
	{
		get
		{
			return this.m_nextLabel;
		}
	}

	public string BackupFile
	{
		get
		{
			return this.m_backupFile;
		}
	}

	private string m_nextLabel;

	private string m_backupFile;
}
