﻿using System;
using System.Collections.Generic;

namespace PrivateMaidMode
{
	public class PrivateSettingManager : WfScreenManager
	{
		public void Awake()
		{
			this.m_advKag = GameMain.Instance.ScriptMgr.adv_kag;
		}

		public override void Start()
		{
			base.Start();
			this.m_moveScreen = base.children_dic["Move"].GetComponent<PrivateCharaSelectMove>();
			if (this.m_advKag.tag_backup != null && this.m_advKag.tag_backup.Count > 0 && this.m_advKag.tag_backup["name"] == "ScenePrivate")
			{
				NDebug.Assert(this.m_advKag.tag_backup.ContainsKey("label"), "SceneCallにlabelの設定がされていませんでした");
				this.m_moveScreen.SetNextLabel(this.m_advKag.tag_backup["label"]);
				this.m_moveScreen.SetBackupFile(this.m_advKag.kag.GetCurrentFileName());
			}
			PrivateCharaSelectMain component = base.children_dic["Main"].GetComponent<PrivateCharaSelectMain>();
			component.SetPrivateSettingManager(this);
			this.CallScreen("Main");
		}

		protected override void SettingChildrenList(Dictionary<string, WfScreenChildren> children_dic)
		{
			string[] array = new string[]
			{
				"Main",
				"Move"
			};
			for (int i = 0; i < array.Length; i++)
			{
				WfScreenChildren component = UTY.GetChildObject(base.gameObject, array[i], false).GetComponent<WfScreenChildren>();
				component.parent_mgr = this;
				children_dic.Add(array[i], component);
			}
		}

		public PrivateCharaSelectMove MoveScreen
		{
			get
			{
				return this.m_moveScreen;
			}
		}

		private PrivateCharaSelectMove m_moveScreen;

		private ADVKagManager m_advKag;
	}
}
