﻿using System;
using System.Collections.Generic;

public class ScenePrivateEventModeAwake : WfScreenManager
{
	public static string returnFile { get; private set; }

	public static string returnLabel { get; private set; }

	public static int callEventId { get; private set; }

	public WfScreenMoveChildren moveScreen { get; private set; }

	private void Awake()
	{
		ScenePrivateEventModeAwake.callEventId = -1;
	}

	public override void Start()
	{
		base.Start();
		ADVKagManager adv_kag = GameMain.Instance.ScriptMgr.adv_kag;
		this.moveScreen = base.children_dic["Move"].GetComponent<WfScreenMoveChildren>();
		if (adv_kag.tag_backup != null && 0 < adv_kag.tag_backup.Count && adv_kag.tag_backup["name"] == "ScenePrivateEventMode")
		{
			if (adv_kag.tag_backup.ContainsKey("start"))
			{
				NDebug.Assert(adv_kag.tag_backup.ContainsKey("file"), "SceneCallにlabelの設定がされていませんでした");
				NDebug.Assert(adv_kag.tag_backup.ContainsKey("label"), "SceneCallにlabelの設定がされていませんでした");
				ScenePrivateEventModeAwake.returnFile = adv_kag.tag_backup["file"];
				ScenePrivateEventModeAwake.returnLabel = adv_kag.tag_backup["label"];
			}
			ScenePrivateEventModeAwake.callEventId = -1;
			int callEventId = 0;
			if (adv_kag.tag_backup.ContainsKey("eventid") && int.TryParse(adv_kag.tag_backup["eventid"], out callEventId))
			{
				ScenePrivateEventModeAwake.callEventId = callEventId;
			}
			this.moveScreen.SetNextLabel(ScenePrivateEventModeAwake.returnLabel);
		}
		this.CallScreen("Main");
	}

	protected override void SettingChildrenList(Dictionary<string, WfScreenChildren> children_dic)
	{
		string[] array = new string[]
		{
			"Main",
			"Move"
		};
		for (int i = 0; i < array.Length; i++)
		{
			WfScreenChildren component = UTY.GetChildObject(base.gameObject, array[i], false).GetComponent<WfScreenChildren>();
			component.parent_mgr = this;
			children_dic.Add(array[i], component);
		}
	}
}
